// Обозначаем пины:
byte  XSTP_pin = A0;   // шаг двигателя катушки (X на рампсе) (нога)
byte  XDIR_pin = A1;   // направление двигателя катушки (нога)
byte  X_EN_pin = A2;   // включение двигателя катушки (нога)

byte  YSTP_pin = A6;   // шаг двигателя каретки (Y на рампсе) (нога)
byte  YDIR_pin = A7;   // направление двигателя каретки (нога)
byte  Y_EN_pin = A8;   // включение двигателя каретки (нога)
// Концевики: (концевики нормально разомкнутые, подключены к +5В одним выходом, другим на Мегу)
byte  Ymin_pin = 14;  // на рампсе Ymin (нога)
byte  Ymax_pin = 18;  // на рампсе Zmin (нога)
//можно использовать только 1 концевик, нам же пофиг на направление движения каретки ;)

////////////////////////
//Константы и прочие полезности:
boolean XDIR = 0, YDIR = 0;           // направление движения моторов, начальные значения
unsigned long Time_mem;
unsigned long Time_now;
unsigned int X_count = 0;         // счетчик шагов Катушки
unsigned int Y_count = 0;         // счетчик шагов Каретки
unsigned long Interval = 100;     // время на итерацию, мСек. Собссно чем больше, тем медденнее идет намотка
boolean flag_HOME = 0;            // если равен 1, то едем домой Кареткой. Не забыть при выставлении этого флага указать направление движения YDIR!!!
byte Dt = 5;                     // время от поднятия ног XSTP или YSTP до их опускания, мСек
unsigned int Otn_XY = 50;        // через сколько шагов катушки будет сделан шаг каретки. Можно подобрать опытным путем, но лучше сначала рассчитать.


byte com = 0;                     // что мы приняли с com-порта

boolean LED = 0;                  // отладка



void setup() {

  ////////////////////////
  //Конфигурируем ноги МК:
  pinMode(13, OUTPUT);            // отладка

  pinMode(XSTP_pin, OUTPUT);
  pinMode(XDIR_pin, OUTPUT);
  pinMode(X_EN_pin, OUTPUT);
  pinMode(YSTP_pin, OUTPUT);
  pinMode(YDIR_pin, OUTPUT);
  pinMode(Y_EN_pin, OUTPUT);
  pinMode(Ymin_pin, INPUT);
  digitalWrite(Ymin_pin, LOW);
  pinMode(Ymax_pin, INPUT);
  digitalWrite(Ymax_pin, LOW);


  // Отладка по COM-порту
  Serial.begin(115200);  // С мегой не работал, у нее портов много, так что пока пробуем 1й


  // Включаем двигатели:
  digitalWrite(X_EN_pin, LOW);        // вроде двигатели включаются подтяжкой к земле ???
  digitalWrite(Y_EN_pin, LOW);        //
  digitalWrite(XDIR_pin, XDIR);
  digitalWrite(YDIR_pin, YDIR);
}

void loop() {
  // Смотрим сколько прошло времени
  Time_now = millis();
  if (Time_now - Time_mem >= Interval) {     // Если прошло достаточно времени, то:
    Time_mem = Time_now;                     // обнуляем время сразу, а то забудем!
    if (digitalRead(Ymin_pin) == 1) {        // Смотрим не сработал ли концевик
      flag_HOME = 0;                         // если да, то прекращаем ехать домой
      YDIR = !YDIR;                          // меняем нарпавление движения каретки на случай, если мы наматывали
      //   digitalWrite(13, LED);              // отладка
      //   LED = !LED;                         // отладка
    }
    if (digitalRead(Ymax_pin) == 1) {        // Смотрим не сработал ли концевик
      flag_HOME = 0;                         // если да, то прекращаем ехать домой
      YDIR = !YDIR;                          // меняем нарпавление движения каретки на случай, если мы наматывали
      //   digitalWrite(13, LED);              // отладка
      //   LED = !LED;                         // отладка
    }

    if (flag_HOME == 1) {                    // если мы едем домой, то
      //digitalWrite(YDIR_pin, YDIR);            // задаем направление движения
      digitalWrite(YSTP_pin, HIGH);          // дрыгаем ногой
      delay(Dt);                             // по поводу задержки я хз сколько она должна быть,
      digitalWrite(YSTP_pin, LOW);           // и вообще, по поводу реализации с delay я в сомненьях, но работать должно :)
    }
    else {                                   // если мы всетаки наматываем катушку, а не едем домой
      digitalWrite(XSTP_pin, HIGH);          // дрыгаем ногой
      delay(Dt);                             //
      digitalWrite(XSTP_pin, LOW);           //
      X_count++;
      if (X_count == Otn_XY) {               // если пора двигать каретку, то
        X_count = 0;                         // обнуляем счетчик шагов катушки
        digitalWrite(YSTP_pin, HIGH);        // двигаем каретку
        delay(Dt);                           //
        digitalWrite(YSTP_pin, LOW);         //
      }
      //   digitalWrite(13, LED);              // отладка
      //   LED = !LED;                         // отладка
    }




    if (Serial.available() > 0) {
      com = Serial.read();                      // читаем com-порт.
      if (com-48==1) {flag_HOME=1;}             //Если пришла 1, то мы едем домой!!!
      if (com-48==0) {flag_HOME=0;}             //Если пришел 0, то мы приехали домой!!!
    }        
  }

}
